//---------------------------------------------------------------------------

#ifndef FFT3_classH
#define FFT3_classH


#define FFT3_STEP0 4      // 4|Cg
#define FFT3_STEP1 7      // XeIM 2 * FFT3_STEP0 - 1Vtg
#define FFT3_FIL0  1      // FFT_FIL0 @FFT3_STEP0|P̃XebvFFTvZ


//---------------------------------------------------------------------------
class TFFT3_class
{

public:
    TFFT3_class(int num_hani);
    ~TFFT3_class();

    int f_fft( double *datas, int mode, int mode_rev);
    int f_fft_overlap_add2(short *in0, short *out, int channel0, int count0);
    int f_4p_map(short *in0, short *out0, int channel0, int size0, bool  first_flag0);

    int return_nzyou0() { return nzyou0; }
    int return_len0()  { return len0; }
    int return_len0_half()  { return len0_half; }  //̒PʂŃf[^̓Vtg
    int rt_code0;
    
    

private:
    int f_zyou( int zyou);
    int f_mkdat( int n);
    int f_iv_mkdat( int n); /* inv  */
    int f_bitrev( int n);
    void f_multc( double *x, double *ws, double *z);
    void f_fftsub(int nh, int offset,int nstep, double datas[], double ws[]);
    int len0,len0_half;
    double *mk;
    double *ivmk;
    double *kaiser_lpf, *kaiser_lpf2, *kaiser_lpf3;
    int    *table;
    double *works, *works2;
    double *works_half;
    double bn1;
    int nzyou0,nzyoux;
    int num_hanix;
    short *iwork_half;
    double *pp0[16];
    

};
#endif
