//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "FFT3_class.h"
#include <math.h>
#include <mem.h>

#include "Unit2.h"
/************************************************/
/*
/*  4{TvǑvZp3{̃tB^[vZ
/*
/************************************************/
/*
/*  2011N123|4@FFTẐȂŗ]ȂƂX
/*  Overlap-add@ǉ FIR̓JCUC[LPFgp
/*
/*************************************************/



//#include "main1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//-----------------------------------------------------------
TFFT3_class::TFFT3_class(int num_hani)
{
      int   kaiser_nzyou,i;
      double  sin1_4;

      rt_code0=0;
      num_hanix=num_hani;

      kaiser_nzyou=int(ceil(log( (double)((2 * num_hani)-1))  /log(2.0)  ));

      // Form2->Memo1->Lines->Add(" kaiser_nzyou = " + IntToStr(kaiser_nzyou));
      nzyou0= kaiser_nzyou+1; // 2{@Ol߁@̂͗f[^
      nzyoux= nzyou0;
      len0=f_zyou( nzyou0);
      len0_half=len0/2;

      for(i=FFT3_FIL0;i<FFT3_STEP0;++i)
      {
       if((pp0[i]  =(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=1;
       else
       {
         // ׂĂɗĂB
         memset((char *)pp0[i], 0, 2 * len0 * sizeof(double));
       }

      }
      // CpX͓߂ŁA㔼ɗǉ[iݍ݂́j㔼ݍ݂ƓɂȂ邻B
      bn1=1.0 /(double) len0;
      sin1_4=sin(M_PI_4);

      kaiser_lpf=pp0[1];
      kaiser_lpf2=pp0[2];
      kaiser_lpf3=pp0[3];

      i=num_hani-1;
      kaiser_lpf[2*i]=sin1_4 / M_PI_4 * bn1;
      kaiser_lpf2[2*i]=1.0 /  M_PI_2 * bn1;
      kaiser_lpf3[2*i]=sin1_4 / (3. * M_PI_4) * bn1;

      // h(i) * x(N-i) ƌvZtɂȕAh(i)̏ԂtɂB
      for(i=1; i < num_hani; ++i)
      {
          kaiser_lpf[2*(i+num_hani-1)] =sin1_4 / ( M_PI_4  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf[2*(i+num_hani-1)]= -1. * kaiser_lpf[2*(i+num_hani-1)];
          kaiser_lpf[2*(num_hani-1-i)] =sin1_4 / ( M_PI_4  - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf[2*(num_hani-1-i)]= -1. * kaiser_lpf[2*(num_hani-1-i)];

          kaiser_lpf3[2*(i+num_hani-1)] =sin1_4 / ( (3. *  M_PI_4)  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf3[2*(i+num_hani-1)]= -1. * kaiser_lpf3[2*(i+num_hani-1)];
          kaiser_lpf3[2*(num_hani-1-i)] =sin1_4 / ( (3. *  M_PI_4)  - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf3[2*(num_hani-1-i)]= -1. * kaiser_lpf3[2*(num_hani-1-i)];

          kaiser_lpf2[2*(i+num_hani-1)] =  1.0 / ( M_PI_2  + (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf2[2*(i+num_hani-1)]= -1. * kaiser_lpf2[2*(i+num_hani-1)];
          kaiser_lpf2[2*(num_hani-1-i)] = 1.0 / ( M_PI_2 - (double)i * M_PI) * bn1;
          if(i%2 == 1) kaiser_lpf2[2*(num_hani-1-i)]= -1. * kaiser_lpf2[2*(num_hani-1-i)];

      }

      ////Form1->Memo1->Lines->Add("+FFT2_class");
      ////for(i=0;i<(len0/2);++i) Form2->Memo1->Lines->Add(" No." + IntToStr(i) + " value=" + FloatToStr(kaiser_lpf2[2*i]));


     f_iv_mkdat( nzyou0);
     f_mkdat( nzyou0 );
     f_bitrev( nzyou0 );
     if((works =(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=100;
     if((works2=(double *)malloc( 2 * (len0+1) * sizeof(double)))==NULL) rt_code0+=200;


     // kaiser_lpf ́@FFTvZĂ
     for(i=FFT3_FIL0;i<FFT3_STEP0;++i)
     {
       f_fft( pp0[i], 0, -1);
     }


     /*
     // for debug set real all 1
     for(i=0;i<(len0);++i)
     {
       kaiser_lpf[2*i]=1.0 * bn1;
       kaiser_lpf[2*i+1]=0.0;
       kaiser_lpf2[2*i]=1.0 * bn1;
       kaiser_lpf2[2*i+1]=0.0;
       kaiser_lpf3[2*i]=1.0 * bn1;
       kaiser_lpf3[2*i+1]=0.0;
       Form2->Memo1->Lines->Add(" No." + IntToStr(i) + " value=" + FloatToStr(kaiser_lpf2[2*i]));
     }
     // end of for debug set real all 1
     */



     // ̓f[^̎̂߂ɕۑĂ
     works_half=(double *)malloc( (2 * (len0+1) /2)  * sizeof(double));
     iwork_half=(short *)malloc( len0_half * 2 * sizeof(short));
}
//----------------------------------------------------------
TFFT3_class::~TFFT3_class()
{
     int i;

     free(ivmk);
     free(mk);
     free(table);
     free(works);
     free(works2);
     for(i=FFT3_FIL0;i<FFT3_STEP0;++i)  free( pp0[i]);
     free(works_half);
     free(iwork_half);

}
//-----------------------------------------------------------
int TFFT3_class::f_zyou( int zyou)
{
   if( zyou < 0)
   {
     return(1);
   }
   else return( 1 << zyou);
}
//----------------------------------------------
int TFFT3_class::f_mkdat( int zyou )
{
   int i,z;
   double x;
   double *p,*p0;

   z= f_zyou(zyou);
   if( (p = (double *)malloc( sizeof(double) * z *2 )  ) == NULL)
   {
       return(-1);
   }
    p0=p;
   for(i=0;i<z;++i)
   {
       x= M_PI * 2.0 *(double)i / (double)z;
       *p= cos(x);
       ++p;
       *p= -sin(x);
       ++p;
   }

   //
   mk=p0;
   return(0);
}
//-----------------------------------------------------------------
int TFFT3_class::f_iv_mkdat( int zyou )
/*  inverted data  */
/*  for i-fft             */
{
   int i,z;
   double x;
   double *p,*p0;

   z= f_zyou(zyou);
   if( (p = (double *)malloc( sizeof(double) * z *2 )  ) == NULL)
   {
      return(-1);
  }
    p0=p;
   for(i=0;i<z;++i)
   {
       x= M_PI * 2.0 *(double)i / (double)z;
       *p= cos(x);
       ++p;
       *p= sin(x);
       ++p;
   }
   //
   ivmk=p0;
   return(0);
}
//----------------------------------------------------------------
int TFFT3_class::f_bitrev(int nzyou)
/* data[0]- data[ 2^^nzyou-1]= 2^^nzyou ko   */
{
   int i,j,x1,x;
   int out;
   int kosuu;
   int *p,*p0;

   kosuu=f_zyou(nzyou);
/*
   printf("\n+starts and setting  bit_rev data ");
*/
  if( (p=(int *)malloc( sizeof(int) * kosuu)) == NULL)
   {
      return(-1);
  }
   p0=p;
   for(i=0;i<kosuu;++i)
   {
     out=0;
     x1=i;
     for(j=nzyou;j>0;--j)
     {
        x = x1 & 0x0001;
        out = out + x*f_zyou(j-1);
        x1>>=1;
     }
     *p=out;
     ++p;
   }
   //
   table=p0;
   return(0);
}
//--------------------------------------------------------
void TFFT3_class::f_multc( double *x, double *ws, double *z)
{
   z[0]     = x[0] * ws[0] - x[1] * ws[1];
   z[1]     = x[0] * ws[1] + x[1] * ws[0];
}

//----------------------------------------------------------
void TFFT3_class::f_fftsub(int nh, int offset,int nstep, double datas[], double ws[])
{
   double a[2];
   int i;
   int x1,x2;

   for(i=0;i<nh;++i)
   {
      x1=2*(i+offset);
      x2=2*(i+nh+offset);
      a[0]= datas[x1] - datas[x2];
      a[1]= datas[x1+1] - datas[x2+1];
      datas[x1]   = datas[x1] + datas[x2];
      datas[x1+1] = datas[x1+1] + datas[x2+1];
      datas[x2]   = a[0] * ws[2*i*nstep]   - a[1] * ws[2*i*nstep+1];
      datas[x2+1] = a[0] * ws[2*i*nstep+1] + a[1] * ws[2*i*nstep];
   }
}
//-----------------------------------------------
int TFFT3_class::f_fft(double *datas, int mode, int mode_rev)
{
/****************************/
/* change malloc method     */
/*  attension!!!                                              */
/*  data[2*i]= real-part; data[1+2*i]= imaginaly-part           */
/* kono subroutone wo yobumaeni ws to table wo set suru koto  */
/*                       set_keisuu(ws, nzyou); bit_rev(table, nzyou) */
/*  data suu ha 2^^nzyou*/
/*  *******************************************************************/
/*  iv-fft: set ws as invmkdata, mode==3                              */
/*  When mode_rev < 0, bir revrese does not done                      */
   int n,nh,i,i1,i2,x1,x2,offset;
   double *ws,a[2];


   /* start fft */
   nh=len0;

   if( mode == 3)
   {
     ws= ivmk;   // MODE=3 eiXI
   }
   else ws=mk;

   for(i1=0;i1<nzyoux;++i1)
   {
         nh= nh/2;
         n= f_zyou(i1);

         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a[0]= datas[x1] - datas[x2];
               a[1]= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];
               datas[x2]   = a[0] * ws[2*i*n]   - a[1] * ws[2*i*n+1];
               datas[x2+1] = a[0] * ws[2*i*n+1] + a[1] * ws[2*i*n];
             }
         }
   }

   /* iff 1/N wo kakeru */
   if( mode == 3)
   {
     for(i=0;i<len0;++i)
     {
       datas[2*i]   = datas[2*i] * bn1;
       datas[2*i+1] = datas[2*i+1] * bn1;
     }
   }



   /* irekae */
   if( mode_rev>= 0)
   {
   for(i=0;i<len0;++i)
   {
     i1= table[i];

     if( i < i1)
     {
      a[0] = datas[2*i1];
      a[1] = datas[2*i1+1];

      datas[2*i1]=datas[2*i];
      datas[2*i1+1]=datas[2*i+1];

      datas[2*i]   = a[0];
      datas[2*i+1] = a[1];
     }

    }
   }

   return(0);
}
//------------------------------------------------------------------

int TFFT3_class::f_fft_overlap_add2(short *in0, short *out0, int channel0, int count0)
//
//  *out0 ́@*in@4{̑傫B
//
//  bit revrse ւȂH
{
   int n,nh,i,i1,i2,x1,x2,offset,loop0,sp0;
   double *ws,*datas,a0,a1;
   short *in0p, *out0p;


   ////Form2->Memo1->Lines->Add(" (f_fft_overlap_add2: len0 = " + IntToStr(len0));

   /*@16BIT MDOBLUE֕ϊ */
   // count0<0 ̂Ƃ́@Ԃ͂߂Ł@Oɗ߂Ă
   datas=works;   // WORKgĂ܂vHHH
   in0p=in0;
   if( count0 < 0)
   {  // ̂݁B
      // Õf[^ɂB
      memset((char *) datas, 0, len0 * sizeof(double) );
      // nstep_default-1 ͑O|Ńf[^ĂB
      for(i=(len0_half - (num_hanix-1));i<len0_half;++i)
      {
        if(channel0==1)  // MONO
        {
           datas[2*i]   = (double) *in0p;
           datas[2*i+1] = 0.;
           ++in0p;
        }
        else   // STEREO
        {
           datas[2*i]   = (double) *in0p;
           ++in0p;
           datas[2*i+1]   = (double) *in0p;
           ++in0p;
        }
     }
   }
   else
   {
      memcpy((char *) datas, (char *) works_half,  len0 * sizeof(double) );
   }


   out0p = out0;
   datas=datas+len0;
 
   for(i=len0_half;i<len0;++i)
   {
     if(channel0==1)  // MONO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas = 0.;
        ++datas;

     }
     else   // STEREO
     {
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
        *datas   = (double) *in0p;
        ++datas;
        ++in0p;
     }
   }

   // ̂߂Ƀf[^ޔ
    datas=works;
    memcpy((char *) works_half, (char *)(datas + len0) , len0 * sizeof(double));


   
   /* ϊ */
   /* start fft */
   nh=len0_half;
   n=1;
   ws=mk;
   for(i1=0;i1<nzyoux;++i1)
   {


         for(i2=0;i2<n;++i2)     // f_fttsub()2@vZĂ̂Ł@1ȂB
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);
            offset=2 * nh*i2;   // nh@Xebvi2Ԗ
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0= datas[x1] - datas[x2];
               a1= datas[x1+1] - datas[x2+1];
               datas[x1]   = datas[x1] + datas[x2];
               datas[x1+1] = datas[x1+1] + datas[x2+1];

               // 2vZĂ
               datas[x2]   = a0 * ws[2*i*n]   - a1 * ws[2*i*n+1];
               datas[x2+1] = a0 * ws[2*i*n+1] + a1 * ws[2*i*n];
             }
         }
         nh=nh>>1;  //nh=nh/2;
         n=n<<1;    //n=n*2;
   }


   /* ϊlۑB */
   memcpy((char *) works2, (char *) datas,  2 * len0 * sizeof(double) );



 for(loop0= FFT3_FIL0;loop0< FFT3_STEP0 ;++loop0)
 {
 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(1): loop0 " + IntToStr(loop0));
    datas= works;
    ws=pp0[loop0];


    if( loop0 > 1)
    {
       // ϊlɖ߂B
       memcpy((char *) datas, (char *) works2,  2 * len0 * sizeof(double) );
    }

    
   /* g̈ŏZ */
 for(i=0;i<len0;++i)
 {
    a0= datas[2*i];
     datas[2*i]   = datas[2*i] * ws[2*i] - datas[2*i+1] * ws[2*i+1];
    datas[2*i+1] = datas[2*i+1] * ws[2*i] + a0 * ws[2*i+1];
 }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(2): loop0 " + IntToStr(loop0));

  /* tϊ */
  /* start fft */

    ////ws=ivmk;   //// wk ̋𕄍tɂĂB
  ws=mk;
  nh=1;
  n=len0_half;
  for(i1=0;i1<nzyoux;++i1)
  {
         for(i2=0;i2<n;++i2)
         {
            ////f_fftsub(nh,2*nh*i2,n,datas,ws);

            offset=2*nh*i2;
            for(i=0;i<nh;++i)
            {
               x1=2*(i+offset);
               x2=2*(i+nh+offset);
               a0   = datas[x2] * ws[2*i*n]   + datas[x2+1] * ws[2*i*n+1];
               a1 = - datas[x2] * ws[2*i*n+1] + datas[x2+1] * ws[2*i*n];
               datas[x2]   = datas[x1] - a0;
               datas[x2+1] =  datas[x1+1] - a1;
               datas[x1]   = datas[x1] + a0;
               datas[x1+1] = datas[x1+1] + a1;
            }

         }
         n=n>>1;    //n=n/2;
         nh=nh<<1;  //nh=nh * 2;
    }

 ///Form2->Memo1->Lines->Add(" (f_fft_overlap_add2(3): loop0 " + IntToStr(loop0));

  
   /*  1/N  */

   if( channel0 == 1) out0p=out0+loop0;
   else out0p=out0+(loop0*2);  // stereo
   datas= works;

   for(i=len0_half;i<len0; ++i)   // Ô͎Ă
   {
      if( channel0 == 1)
      {
        a0 = datas[2*i];
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45

        }
        out0p+= FFT3_STEP0;
      }
      else
      {  //stereo
        a0 = datas[2*i];  //    * bn1;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45
        }
        ++out0p;

        a0 = datas[2*i+1]; //   * bn1;
        if(a0 >=0)
        {
             if(a0 > 32767.) a0=32767.;
             *out0p= (short)(a0 + 0.5);   // 45
        }
        else
        {
             if(a0 < -32768.) a0=-32768.;
             *out0p= (short)(a0 - 0.5);  // 45
        }
        out0p+= FFT3_STEP1;
       } //stereo
   }

   } //  for(loop0=1;loop0<4;++loop0)


   return(0);

}
//  bit revrse ւȂH
//--------------------------------------------------------------------
int TFFT3_class::f_4p_map(short *in0, short *out0, int channel0, int size0, bool first_flag0)
{

 int i,c0;
 char *cp0;
 short *sp0;

 c0=size0/channel0;

 if(first_flag0)
 {
   for(i=0;i<c0;++i)
   {
     if(channel0 == 1)
     {
       out0[ FFT3_STEP0 *i]=in0[i];
     }
     else
     {
       out0[2*( FFT3_STEP0 *i)]  = in0[2 * i];
       out0[2*( FFT3_STEP0 *i)+1]= in0[2 * i + 1];
     }
   }

   cp0=(char *)in0;
   cp0 += (size0 * sizeof(short));
   memcpy((char *)iwork_half, cp0, (num_hanix-1) * channel0 * sizeof(short));
 }
 else
 {
  sp0=in0;
  for(i=0;i<c0;++i)
   {
     if(i< (num_hanix-1))
     {
       if(channel0 == 1)
       {
         out0[ FFT3_STEP0 *i]=iwork_half[i];
       }
       else
       {
         out0[2*( FFT3_STEP0 *i )]  = iwork_half[2 * i];
         out0[2*( FFT3_STEP0 * i) + 1]= iwork_half[2 * i + 1];
       }
     }
     else
     {
        if(channel0 == 1)
        {
          out0[ FFT3_STEP0 *i]=*sp0;
          ++sp0;
        }
        else
        {
          out0[2*( FFT3_STEP0 *i)]  = *sp0;
          ++sp0;
          out0[2*( FFT3_STEP0 *i)+1]= *sp0;
          ++sp0;
        }
     }
   }
   cp0=(char *)sp0;
   memcpy((char *)iwork_half, cp0, (num_hanix-1) * channel0 * sizeof(short));


 }

 return 0;
}
//--------------------------------------------------------------------
